(HDU 5726)GCD <RMQ + map + 二分> 多校训练1

15 篇文章 0 订阅
8 篇文章 0 订阅

GCD
Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 3087 Accepted Submission(s): 1116

Problem Description
Give you a sequence of N(N≤100,000) integers : a1,…,an(0< ai≤1000,000,000). There are Q(Q≤100,000) queries. For each query l,r you have to calculate gcd(al,,al+1,…,ar) and count the number of pairs(l′,r′)(1≤l < r≤N)such that gcd(al′,al′+1,…,ar′) equal gcd(al,al+1,…,ar).

Input
The first line of input contains a number T, which stands for the number of test cases you need to solve.

The first line of each case contains a number N, denoting the number of integers.

The second line contains N integers, a1,…,an(0< ai≤1000,000,000).

The third line contains a number Q, denoting the number of queries.

For the next Q lines, i-th line contains two number , stand for the li,ri, stand for the i-th queries.

Output
For each case, you need to output “Case #:t” at the beginning.(with quotes, t means the number of the test case, begin from 1).

For each query, you need to output the two numbers in a line. The first number stands for gcd(al,al+1,…,ar) and the second number stands for the number of pairs(l′,r′) such that gcd(al′,al′+1,…,ar′) equal gcd(al,al+1,…,ar).

Sample Input
1
5
1 2 4 6 7
4
1 5
2 4
3 4
4 4

Sample Output
Case #1:
1 8
2 4
2 4
6 1

Author
HIT

Source
2016 Multi-University Training Contest 1

题意:
给你n给整数,有q次查询,问题1:每次查询问你a[l..r]区间的数的gcd为多少。问题2:并且问你在所有区间中区间gcd的值等于该查询区间的gcd值的区间个数?

分析:
我们很快可以想到O(n^2)的算法,但是会超时。
后来我想到了用线段树来解决查询的问题,但是很难解决告诉区间数的问题。

对于问题1我们可以用RMQ或线段树来解决(我用的是RMQ,因为方便后面)

对于问题二:由于区间的个数有O(n^2)个,而我们要是按照常规思路枚举左右端点会超时

但是我们会发现,在做端点固定额情况下,所有的结果是一个非递增的序列
利用这一点我们可以枚举左端点,然后利用二分法快速找出每一段的长度
二分:
在二分时我们枚举左端点i,然后查看区间a[i..np]的值(np从i开始),再利用二分法在区间[np,n]中找出和当前区间gcd值相同的最右端即可。

由于a[i]很大,我们不可能先开一个1e9的数组,所以我们用map来管理

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <map>
#include <algorithm>
using namespace std;
typedef long long LL;

const int maxn = 100010;
int a[maxn],ans[maxn];
int dp[maxn][20];
int n,q;
map<int,LL> mp;

int gcd(int a,int b)
{
    return b == 0? a: gcd(b,a%b);
}

void rmq()
{
    for(int i=1;i<=n;i++) dp[i][0] = a[i];

    for(int j=1;(1<<j)<=n;j++)
    {
        for(int i=1;i+(1<<j)-1<=n;i++)
        {
            dp[i][j] = gcd(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
        }
    }
}

int findgcd(int l,int r)
{
    int k = 0;
    while(1<<(k+1)<=r-l+1) k++;
    return gcd(dp[l][k],dp[r-(1<<k)+1][k]);
}



int main()
{
    int t,l,r,kase=1;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(int i=1;i<=n;i++) scanf("%d",&a[i]);
        rmq();
        scanf("%d",&q);
        for(int i=1;i<=q;i++)
        {
            scanf("%d%d",&l,&r);
            ans[i] = findgcd(l,r);
            mp[ans[i]] = 0;
        }

        for(int i=1;i<=n;i++)
        {
            int  np = i;
            while(np <= n)
            {
                int tmp = findgcd(i,np);
                int l = np, r = n;
                int cnt = 0;
                while(l <= r)
                {
                    int mid = (l+r)/2;
                    if(findgcd(i,mid) < tmp) r = mid -1;
                    else
                    {
                        l = mid +1;
                        cnt = mid;
                    }
                }
                mp[tmp] += cnt - np + 1;
                np = r + 1;
            }
        }

        printf("Case #%d:\n",kase++);
        for(int i=1;i<=q;i++) printf("%d %lld\n",ans[i],mp[ans[i]]);
    }
    return 0;
}
  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值